//------------------------------------------------------------------
// original ised and first implementation by mony
// tris version by mladen
//------------------------------------------------------------------
#property copyright "mony & mladen"
#property link      "made at www.forex.tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;          // Time frame to use
extern int                CCIperiod       = 3;              // CCI period
extern int                ATRperiod       = 300;            // ATR period
extern ENUM_APPLIED_PRICE applied_price   = PRICE_TYPICAL;  // Price to use
extern bool               alertsOn        = true;           // Turn alerts on
extern bool               alertsOnCurrent = false;          // Alerts on current (still opened) bar
extern bool               alertsMessage   = true;           // Alerts should display pop-up message
extern bool               alertsSound     = false;          // Alerts should play sound
extern bool               alertsNotify    = false;          // Alerts should send notification
extern bool               alertsEmail     = false;          // Alerts should send enail
extern string             soundFile       = "alert2.wav";   // Sound file t use for sound alerts

double TrLine[];
double HistUp[];
double HistDn[];
double trend[];
string indicatorFileName;
bool   returnBars;



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, HistUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, HistDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, TrLine);
   SetIndexBuffer(3, trend);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { HistUp[0] = limit+1; return(0); }
         if (TimeFrame!=_Period)
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));  
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  HistUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CCIperiod,ATRperiod,applied_price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
                  HistDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CCIperiod,ATRperiod,applied_price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
            }               
            return(0);
         }               

   //
   //
   //
   //
   //
   
   for(int i=limit; i >= 0; i--) 
   {
      double cciTrendNow = iCCI(NULL, 0, CCIperiod, applied_price, i);
      if (cciTrendNow >= 0) 
         {
            TrLine[i] = NormalizeDouble(Low[i] - iATR(NULL, 0, ATRperiod, i),Digits);    
               if (i<(Bars-1) && TrLine[i] < TrLine[i+1]) TrLine[i] = TrLine[i+1];
         }
         if (cciTrendNow <= 0) 
         {
            TrLine[i] = NormalizeDouble(High[i] + iATR(NULL, 0, ATRperiod, i),Digits);
               if (i<(Bars-1) && TrLine[i] > TrLine[i+1]) TrLine[i] = TrLine[i+1];
         }

         //
         //
         //
         //
         //
         
         HistUp[i] = EMPTY_VALUE;
         HistDn[i] = EMPTY_VALUE;
         if (i<(Bars-1))
         {
            trend[i] = trend[i+1];
               if (TrLine[i]> TrLine[i+1]) trend[i] = 1;
               if (TrLine[i]< TrLine[i+1]) trend[i] =-1;
               if (trend[i] ==  1) HistUp[i] = 1;
               if (trend[i] == -1) HistDn[i] = 1;
         }
   }              
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" SP MY trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(Symbol()+" S P MY",message);
          if (alertsSound)   PlaySound(soundFile);
   }
}